#include "bla_easy.h"

#define aMAX 447
#define STEP (14.0 / 0x100000)
#define DN 4

int main(int argc, const char **argv)
{
	int x, y, n, sx, sy, sn, c;
	double zx, zy, cx, cy, xx, yy, tx, ty;
	Window *win = openWin(512, 384, "mandel");
	for (y = 0; y < 384; y++) {
		for (x = 0; x < 512; x++) {
			sn = 0;
			for (sx = 0; sx < DN; sx++) {
				cx = (double) 0x4750 / 0x10000 + (x * DN + sx) * (STEP / DN);
				for (sy = 0; sy < DN; sy++) {
					cy = (double) -0x1e8 / 0x10000 - (y * DN + sy) * (STEP / DN);
					zx = zy = 0;
					for (n = 0; n < aMAX; n++) {
						xx = zx * zx;
						yy = zy * zy;
						if (xx + yy > 4) break;
						tx = xx - yy;
						ty = zx * zy * 2;
						zx = tx + cx;
						zy = ty + cy;
					}
					sn += n;
				}
			}
			n = sn / (DN * DN);
			c = 0;
			if (n < 256)
				c = rgb(n, 0, 0);
			else if (n < aMAX)
				c = rgb(255, n - 255, 0);
			setPix(win, x, y, c);
		}
		waitEx(0); // f`FbN.
		leapFlushAll(win, 300);
	}
	printf("time=%.3f[sec]\n", (double) clock() / CLOCKS_PER_SEC);
	end();
}

