// bla.c for Windows   by 썇G  CZXKL-01.

#include "bla.h"
#include <stdlib.h>

#define bla_TABLESIZ	16

static bla_Window *bla_table_w[bla_TABLESIZ];

static void putKeybuf(bla_Window *w, int c)
{
	if (((w->kbw + 1) & (bla_KEYBUFSIZ - 1)) != w->kbr) {
		w->keybuf[w->kbw] = c;
		w->kbw = (w->kbw + 1) & (bla_KEYBUFSIZ - 1);
	}
	return;
}

// level0

int main(int argc, const char **argv)
{
	int i = bla_main(argc, argv);
	bla_exit(i);
}

static HWND bla_table_hw[bla_TABLESIZ];

static LRESULT CALLBACK WndProc(HWND hw, unsigned int msg, WPARAM wp, LPARAM lp);

static int winthread(bla_Window *w)
{
	WNDCLASSEX wc;
	RECT r;
	int i, x, y;
	MSG msg;

	x = w->xsiz;
	y = w->ysiz;

	wc.cbSize = sizeof (WNDCLASSEX);
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = w->hInst;
	wc.hIcon = (HICON) LoadImage(NULL, MAKEINTRESOURCE(IDI_APPLICATION),
		IMAGE_ICON, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
	wc.hIconSm = wc.hIcon;
	wc.hCursor = (HCURSOR)LoadImage(NULL, MAKEINTRESOURCE(IDC_ARROW),
		IMAGE_CURSOR, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
	wc.hbrBackground = (HBRUSH) COLOR_APPWORKSPACE;
	wc.lpszMenuName = NULL;
	wc.lpszClassName = w->title;
	if (RegisterClassEx(&wc) == 0)
		return 1;
	r.left = 0;
	r.top = 0;
	r.right = x;
	r.bottom = y;
	AdjustWindowRect(&r, WS_OVERLAPPEDWINDOW, FALSE);
	x = r.right - r.left;
	y = r.bottom - r.top;

	w->hWnd = CreateWindowA(wc.lpszClassName, w->title, WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, CW_USEDEFAULT, x, y, NULL, NULL,	w->hInst, NULL);
	if (w->hWnd == NULL)
		return 1;
	bla_table_hw[w->table_idx] = w->hWnd;
	ShowWindow(w->hWnd, SW_SHOW);
	UpdateWindow(w->hWnd);

	for (;;) {
		i = GetMessage(&msg, NULL, 0, 0);
		if (i == 0 || i == -1)	/* G[͏IbZ[W */
			break;
		/* ̂ق͂Ƃ肠ftHg */
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	// ̃^C~OfreeĂ͂Ȃ.
	UnregisterClass(w->title, w->hInst);
	w->phase = 2;
	return 0;
}

static int getKeyState0()
{
	int i = 0;
	if ((GetKeyState(VK_LSHIFT)   & (1 << 15)) != 0) i |= 1 << 16;
	if ((GetKeyState(VK_NUMLOCK)  & (1 <<  0)) != 0) i |= 1 << 22;
	if ((GetKeyState(VK_CAPITAL)  & (1 <<  0)) != 0) i |= 1 << 23;
	if ((GetKeyState(VK_RSHIFT)   & (1 << 15)) != 0) i |= 1 << 24;
	return i;	
}

static int getKeyState1()
{
	int j = 0;
	if ((GetKeyState(VK_LCONTROL) & (1 << 15)) != 0) j |= 1 << 17;
	if ((GetKeyState(VK_LMENU)    & (1 << 15)) != 0) j |= 1 << 18;
	if ((GetKeyState(VK_RCONTROL) & (1 << 15)) != 0) j |= 1 << 25;
	if ((GetKeyState(VK_RMENU)    & (1 << 15)) != 0) j |= 1 << 26;
	return j;	
}

static LRESULT CALLBACK WndProc(HWND hw, unsigned int msg, WPARAM wp, LPARAM lp)
{
	bla_Window *w;
	int i, j;
	for (i = 0; i < bla_TABLESIZ; i++) {
		if (bla_table_hw[i] == hw)
			break;
	}
	if (i >= bla_TABLESIZ)
		return DefWindowProc(hw, msg, wp, lp);
	w = bla_table_w[i];
	if (msg == WM_PAINT) {
		PAINTSTRUCT ps;
		HDC hdc = BeginPaint(hw, &ps);
		SetDIBitsToDevice(hdc, 0, 0, w->xsiz, w->ysiz,
			0, 0, 0, w->ysiz, w->buf, &w->bmi, DIB_RGB_COLORS);
		EndPaint(hw, &ps);
		return 0;
	}
	if (msg == WM_DESTROY) {
		PostQuitMessage(0); // ȂƃXbhIȂ.
		return 0;
	}
	if (msg == WM_KEYDOWN || msg == WM_SYSKEYDOWN) {
		i = -1;
		if (wp == VK_RETURN)	i = bla_KEY_ENTER;
		if (wp == VK_ESCAPE)	i = bla_KEY_ESC;
		if (wp == VK_BACK)		i = bla_KEY_BACKSPACE;
		if (wp == VK_TAB)		i = bla_KEY_TAB;
		if (wp == VK_PRIOR)		i = bla_KEY_PAGEUP;
		if (wp == VK_NEXT)		i = bla_KEY_PAGEDWN;
		if (wp == VK_END)		i = bla_KEY_END;
		if (wp == VK_HOME)		i = bla_KEY_HOME;
		if (wp == VK_LEFT)		i = bla_KEY_LEFT;
		if (wp == VK_RIGHT)		i = bla_KEY_RIGHT;
		if (wp == VK_UP)		i = bla_KEY_UP;
		if (wp == VK_DOWN)		i = bla_KEY_DOWN;
		if (wp == VK_INSERT)	i = bla_KEY_INS;
		if (wp == VK_DELETE)	i = bla_KEY_DEL;
		j = getKeyState1();
		if (j != 0 && ' ' <= wp && wp <= 0x7e)
			i = wp;	// CtrlAltƉĂꍇ́Aput.
		i |= getKeyState0();
		if (i != -1) {
			putKeybuf(w, i | j);
			return 0;
		}
	}
//	if (msg == WM_KEYUP) { i = 0xfff; }
	if (msg == WM_CHAR) {
		if (' ' <= wp && wp <= 0x7e) {
			i = wp | getKeyState0();
			j = getKeyState1();
			putKeybuf(w, i | j);
			return 0;
		}
	}
	return DefWindowProc(hw, msg, wp, lp);
}

bla_Window *bla_openWin(int x, int y, const char *t)
{
	int i, j;
	for (i = 0; i < bla_TABLESIZ; i++) {
		if (bla_table_w[i] == 0) break;
	}
	if (i >= bla_TABLESIZ) return 0;

	bla_Window *w = malloc(sizeof (bla_Window));
	bla_table_w[i] = w;
	w->table_idx = i;
	w->title[0] = '\0';
	if (t != 0) {
		strncpy(w->title, t, 63);
		w->title[63] = '\0';
	}
	if (w->title[0] == '\0') {
		w->title[0] = ' ';
		w->title[1] = '\0';
	}
	w->kbw = w->kbr = 0;
	w->phase = 1;
	w->xsiz = x;
	w->ysiz = y;
	w->buf = malloc(x * y * sizeof (int));
	w->lastFlush = clock();
	w->mode = bla_MODE_SET;
#if 0
	w->cx = pwtp->cy = 0;
	w->col = 0xffffff;
	w->bcol = 0;
	w->gets_ph = 0;
#endif
	bla_fillRect(w, x, y, 0, 0, 0);

	w->bmi.bmiHeader.biSize = sizeof (BITMAPINFOHEADER);
	w->bmi.bmiHeader.biWidth = x;
	w->bmi.bmiHeader.biHeight = - y;
	w->bmi.bmiHeader.biPlanes = 1;
	w->bmi.bmiHeader.biBitCount = 32;
	w->bmi.bmiHeader.biCompression = BI_RGB;
	CreateThread(NULL, 0, (void *) &winthread, (void *) w, 0, (void *) &i);
	return w;
}

void bla_flushAll(bla_Window *w)
{
	if (w->phase == 1) {
		InvalidateRect(w->hWnd, NULL, FALSE);
		UpdateWindow(w->hWnd);
		w->lastFlush = clock();
	}
	return;
}

void bla_wait(int msec)
{
	Sleep(msec);
	return;
}

void bla_closeWin(bla_Window *w)
{
	if (w->phase == 1) {
		PostMessage(w->hWnd, WM_CLOSE, 0, 0);
		while (w->phase == 1)
			bla_wait(128);
	}

	free(w->buf);
	bla_table_w[w->table_idx] = 0;
	free(w);
	return;
}

void bla_exit(int c) { exit(c); }

// level1

void bla_end()
{
	int i, j;
	for (i = 0; i < bla_TABLESIZ; i++) {
		bla_Window *w = bla_table_w[i];
		if (w == 0) continue;
		bla_flushAll(w);
	}
	for (;;) {
		for (i = 0; i < bla_TABLESIZ; i++) {
			bla_Window *w = bla_table_w[i];
			if (w == 0) continue;
			if (w->phase == 2)
				bla_closeWin(w);
		}
		j = 0;
		for (i = 0; i < bla_TABLESIZ; i++) {
			bla_Window *w = bla_table_w[i];
			if (w == 0) continue;
			j++;
		}
		if (j == 0) break;
		bla_wait(128);
	}
	bla_exit(0);
}

void bla_leapFlushAll(bla_Window *w, unsigned int t)
{
	if (t == 0 || (double) (clock() - w->lastFlush) * (1000.0 / (double) CLOCKS_PER_SEC) >= (double) t)
		bla_flushAll(w);
	return;
}

int bla_inkey(bla_Window *w)
{
	int i;
	if (w->kbr == w->kbw) return 0;
	i = w->keybuf[w->kbr];
	w->kbr = (w->kbr + 1) & (bla_KEYBUFSIZ - 1);
	return i;
}

int bla_inkey0(bla_Window *w)
{
	if (w->kbr == w->kbw) return 0;
	return w->keybuf[w->kbr];
}

void bla_setPixEx(bla_Window *w, int x, int y, int c)
{
	if (c >= 0 && 0 <= x && x < w->xsiz && 0 <= y && y < w->ysiz) {
		if (w->mode == bla_MODE_SET) w->buf[y * w->xsiz + x] =  c;
		if (w->mode == bla_MODE_OR)  w->buf[y * w->xsiz + x] |= c;
		if (w->mode == bla_MODE_AND) w->buf[y * w->xsiz + x] &= c;
		if (w->mode == bla_MODE_XOR) w->buf[y * w->xsiz + x] ^= c;
	}
	return;
}

void bla_fillRect(bla_Window *w, int sx, int sy, int x0, int y0, int c)
{
	int i, j, *b = w->buf + x0 + y0 * w->xsiz;
	for (j = 0; j < sy; j++) {
		for (i = 0; i < sx; i++)
			b[i] = c;
		b += w->xsiz;
	}
	return;
}

void bla_fillRectEx(bla_Window *w, int sx, int sy, int x0, int y0, int c)
{
	int i, j;
	for (j = 0; j < sy; j++) {
		for (i = 0; i < sx; i++) {
			bla_setPixEx(w, x0 + i, y0 + j, c);
		}
	}
	return;
}

void bla_drawRect(bla_Window *w, int sx, int sy, int x0, int y0, int c)
{
	if (sx <= 1 || sy <= 1)
		bla_fillRect(w, sx, sy, x0, y0, c);
	else {
		bla_fillRect(w, sx, 1,      x0,          y0,          c);
		bla_fillRect(w, sx, 1,      x0,          y0 + sy - 1, c);
		bla_fillRect(w, 1,  sy - 2, x0,          y0 + 1,      c);
		bla_fillRect(w, 1,  sy - 2, x0 + sx - 1, y0 + 1,      c);
	}
	return;
}

void bla_drawRectEx(bla_Window *w, int sx, int sy, int x0, int y0, int c)
{
	if (sx <= 1 || sy <= 1)
		bla_fillRectEx(w, sx, sy, x0, y0, c);
	else {
		bla_fillRectEx(w, sx, 1,      x0,          y0,          c);
		bla_fillRectEx(w, sx, 1,      x0,          y0 + sy - 1, c);
		bla_fillRectEx(w, 1,  sy - 2, x0,          y0 + 1,      c);
		bla_fillRectEx(w, 1,  sy - 2, x0 + sx - 1, y0 + 1,      c);
	}
	return;
}

static unsigned char fontdata[] = {
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x00, 0x00, 0x10, 0x10, 0x00, 0x00,
	0x28, 0x28, 0x28, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x44, 0x44, 0x44, 0xfe, 0x44, 0x44, 0x44, 0x44, 0x44, 0xfe, 0x44, 0x44, 0x44, 0x00, 0x00,
	0x10, 0x3a, 0x56, 0x92, 0x92, 0x90, 0x50, 0x38, 0x14, 0x12, 0x92, 0x92, 0xd4, 0xb8, 0x10, 0x10,
	0x62, 0x92, 0x94, 0x94, 0x68, 0x08, 0x10, 0x10, 0x20, 0x2c, 0x52, 0x52, 0x92, 0x8c, 0x00, 0x00,
	0x00, 0x70, 0x88, 0x88, 0x88, 0x90, 0x60, 0x47, 0xa2, 0x92, 0x8a, 0x84, 0x46, 0x39, 0x00, 0x00,
	0x04, 0x08, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x02, 0x04, 0x08, 0x08, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x08, 0x08, 0x04, 0x02, 0x00,
	0x80, 0x40, 0x20, 0x20, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x20, 0x20, 0x40, 0x80, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x92, 0x54, 0x38, 0x54, 0x92, 0x10, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x10, 0x10, 0x10, 0xfe, 0x10, 0x10, 0x10, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x08, 0x08, 0x10,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00,
	0x02, 0x02, 0x04, 0x04, 0x08, 0x08, 0x08, 0x10, 0x10, 0x20, 0x20, 0x40, 0x40, 0x40, 0x80, 0x80,
	0x00, 0x18, 0x24, 0x24, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x24, 0x24, 0x18, 0x00, 0x00,
	0x00, 0x08, 0x18, 0x28, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x3e, 0x00, 0x00,
	0x00, 0x18, 0x24, 0x42, 0x42, 0x02, 0x04, 0x08, 0x10, 0x20, 0x20, 0x40, 0x40, 0x7e, 0x00, 0x00,
	0x00, 0x18, 0x24, 0x42, 0x02, 0x02, 0x04, 0x18, 0x04, 0x02, 0x02, 0x42, 0x24, 0x18, 0x00, 0x00,
	0x00, 0x0c, 0x0c, 0x0c, 0x14, 0x14, 0x14, 0x24, 0x24, 0x44, 0x7e, 0x04, 0x04, 0x1e, 0x00, 0x00,
	0x00, 0x7c, 0x40, 0x40, 0x40, 0x58, 0x64, 0x02, 0x02, 0x02, 0x02, 0x42, 0x24, 0x18, 0x00, 0x00,
	0x00, 0x18, 0x24, 0x42, 0x40, 0x58, 0x64, 0x42, 0x42, 0x42, 0x42, 0x42, 0x24, 0x18, 0x00, 0x00,
	0x00, 0x7e, 0x42, 0x42, 0x04, 0x04, 0x08, 0x08, 0x08, 0x10, 0x10, 0x10, 0x10, 0x38, 0x00, 0x00,
	0x00, 0x18, 0x24, 0x42, 0x42, 0x42, 0x24, 0x18, 0x24, 0x42, 0x42, 0x42, 0x24, 0x18, 0x00, 0x00,
	0x00, 0x18, 0x24, 0x42, 0x42, 0x42, 0x42, 0x42, 0x26, 0x1a, 0x02, 0x42, 0x24, 0x18, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00, 0x00, 0x00, 0x18, 0x18, 0x08, 0x08, 0x10,
	0x00, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x00, 0x00, 0xfe, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x80, 0x00,
	0x00, 0x38, 0x44, 0x82, 0x82, 0x82, 0x04, 0x08, 0x10, 0x10, 0x00, 0x00, 0x18, 0x18, 0x00, 0x00,
	0x00, 0x38, 0x44, 0x82, 0x9a, 0xaa, 0xaa, 0xaa, 0xaa, 0xaa, 0x9c, 0x80, 0x46, 0x38, 0x00, 0x00,
	0x00, 0x18, 0x18, 0x18, 0x18, 0x24, 0x24, 0x24, 0x24, 0x7e, 0x42, 0x42, 0x42, 0xe7, 0x00, 0x00,
	0x00, 0xf0, 0x48, 0x44, 0x44, 0x44, 0x48, 0x78, 0x44, 0x42, 0x42, 0x42, 0x44, 0xf8, 0x00, 0x00,
	0x00, 0x3a, 0x46, 0x42, 0x82, 0x80, 0x80, 0x80, 0x80, 0x80, 0x82, 0x42, 0x44, 0x38, 0x00, 0x00,
	0x00, 0xf8, 0x44, 0x44, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x44, 0x44, 0xf8, 0x00, 0x00,
	0x00, 0xfe, 0x42, 0x42, 0x40, 0x40, 0x44, 0x7c, 0x44, 0x40, 0x40, 0x42, 0x42, 0xfe, 0x00, 0x00,
	0x00, 0xfe, 0x42, 0x42, 0x40, 0x40, 0x44, 0x7c, 0x44, 0x44, 0x40, 0x40, 0x40, 0xf0, 0x00, 0x00,
	0x00, 0x3a, 0x46, 0x42, 0x82, 0x80, 0x80, 0x9e, 0x82, 0x82, 0x82, 0x42, 0x46, 0x38, 0x00, 0x00,
	0x00, 0xe7, 0x42, 0x42, 0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x42, 0xe7, 0x00, 0x00,
	0x00, 0x7c, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x7c, 0x00, 0x00,
	0x00, 0x1f, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x84, 0x48, 0x30, 0x00,
	0x00, 0xe7, 0x42, 0x44, 0x48, 0x50, 0x50, 0x60, 0x50, 0x50, 0x48, 0x44, 0x42, 0xe7, 0x00, 0x00,
	0x00, 0xf0, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x42, 0x42, 0xfe, 0x00, 0x00,
	0x00, 0xc3, 0x42, 0x66, 0x66, 0x66, 0x5a, 0x5a, 0x5a, 0x42, 0x42, 0x42, 0x42, 0xe7, 0x00, 0x00,
	0x00, 0xc7, 0x42, 0x62, 0x62, 0x52, 0x52, 0x52, 0x4a, 0x4a, 0x4a, 0x46, 0x46, 0xe2, 0x00, 0x00,
	0x00, 0x38, 0x44, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x44, 0x38, 0x00, 0x00,
	0x00, 0xf8, 0x44, 0x42, 0x42, 0x42, 0x44, 0x78, 0x40, 0x40, 0x40, 0x40, 0x40, 0xf0, 0x00, 0x00,
	0x00, 0x38, 0x44, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x82, 0x92, 0x8a, 0x44, 0x3a, 0x00, 0x00,
	0x00, 0xfc, 0x42, 0x42, 0x42, 0x42, 0x7c, 0x44, 0x42, 0x42, 0x42, 0x42, 0x42, 0xe7, 0x00, 0x00,
	0x00, 0x3a, 0x46, 0x82, 0x82, 0x80, 0x40, 0x38, 0x04, 0x02, 0x82, 0x82, 0xc4, 0xb8, 0x00, 0x00,
	0x00, 0xfe, 0x92, 0x92, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x7c, 0x00, 0x00,
	0x00, 0xe7, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x24, 0x3c, 0x00, 0x00,
	0x00, 0xe7, 0x42, 0x42, 0x42, 0x42, 0x24, 0x24, 0x24, 0x24, 0x18, 0x18, 0x18, 0x18, 0x00, 0x00,
	0x00, 0xe7, 0x42, 0x42, 0x42, 0x5a, 0x5a, 0x5a, 0x5a, 0x24, 0x24, 0x24, 0x24, 0x24, 0x00, 0x00,
	0x00, 0xe7, 0x42, 0x42, 0x24, 0x24, 0x24, 0x18, 0x24, 0x24, 0x24, 0x42, 0x42, 0xe7, 0x00, 0x00,
	0x00, 0xee, 0x44, 0x44, 0x44, 0x28, 0x28, 0x28, 0x10, 0x10, 0x10, 0x10, 0x10, 0x7c, 0x00, 0x00,
	0x00, 0xfe, 0x84, 0x84, 0x08, 0x08, 0x10, 0x10, 0x20, 0x20, 0x40, 0x42, 0x82, 0xfe, 0x00, 0x00,
	0x00, 0x3e, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x20, 0x3e, 0x00,
	0x80, 0x80, 0x40, 0x40, 0x20, 0x20, 0x20, 0x10, 0x10, 0x08, 0x08, 0x04, 0x04, 0x04, 0x02, 0x02,
	0x00, 0x7c, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x7c, 0x00,
	0x00, 0x10, 0x28, 0x44, 0x82, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x00,
	0x10, 0x08, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x70, 0x08, 0x04, 0x3c, 0x44, 0x84, 0x84, 0x8c, 0x76, 0x00, 0x00,
	0xc0, 0x40, 0x40, 0x40, 0x40, 0x58, 0x64, 0x42, 0x42, 0x42, 0x42, 0x42, 0x64, 0x58, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x4c, 0x84, 0x84, 0x80, 0x80, 0x82, 0x44, 0x38, 0x00, 0x00,
	0x0c, 0x04, 0x04, 0x04, 0x04, 0x34, 0x4c, 0x84, 0x84, 0x84, 0x84, 0x84, 0x4c, 0x36, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x38, 0x44, 0x82, 0x82, 0xfc, 0x80, 0x82, 0x42, 0x3c, 0x00, 0x00,
	0x0e, 0x10, 0x10, 0x10, 0x10, 0x7c, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x7c, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x36, 0x4c, 0x84, 0x84, 0x84, 0x84, 0x4c, 0x34, 0x04, 0x04, 0x78,
	0xc0, 0x40, 0x40, 0x40, 0x40, 0x58, 0x64, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0xe3, 0x00, 0x00,
	0x00, 0x10, 0x10, 0x00, 0x00, 0x30, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x38, 0x00, 0x00,
	0x00, 0x04, 0x04, 0x00, 0x00, 0x0c, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x08, 0x08, 0x30,
	0xc0, 0x40, 0x40, 0x40, 0x40, 0x4e, 0x44, 0x48, 0x50, 0x60, 0x50, 0x48, 0x44, 0xe6, 0x00, 0x00,
	0x30, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x38, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0xf6, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0x49, 0xdb, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0xd8, 0x64, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0xe3, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x38, 0x44, 0x82, 0x82, 0x82, 0x82, 0x82, 0x44, 0x38, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0xd8, 0x64, 0x42, 0x42, 0x42, 0x42, 0x42, 0x64, 0x58, 0x40, 0xe0,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x34, 0x4c, 0x84, 0x84, 0x84, 0x84, 0x84, 0x4c, 0x34, 0x04, 0x0e,
	0x00, 0x00, 0x00, 0x00, 0x00, 0xdc, 0x62, 0x42, 0x40, 0x40, 0x40, 0x40, 0x40, 0xe0, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0x7a, 0x86, 0x82, 0xc0, 0x38, 0x06, 0x82, 0xc2, 0xbc, 0x00, 0x00,
	0x00, 0x00, 0x10, 0x10, 0x10, 0x7c, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x0e, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0xc6, 0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x46, 0x3b, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0xe7, 0x42, 0x42, 0x42, 0x24, 0x24, 0x24, 0x18, 0x18, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0xe7, 0x42, 0x42, 0x5a, 0x5a, 0x5a, 0x24, 0x24, 0x24, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0xc6, 0x44, 0x28, 0x28, 0x10, 0x28, 0x28, 0x44, 0xc6, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x00, 0xe7, 0x42, 0x42, 0x24, 0x24, 0x24, 0x18, 0x18, 0x10, 0x10, 0x60,
	0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x82, 0x84, 0x08, 0x10, 0x20, 0x42, 0x82, 0xfe, 0x00, 0x00,
	0x00, 0x06, 0x08, 0x10, 0x10, 0x10, 0x10, 0x60, 0x10, 0x10, 0x10, 0x10, 0x08, 0x06, 0x00, 0x00,
	0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10,
	0x00, 0x60, 0x10, 0x08, 0x08, 0x08, 0x08, 0x06, 0x08, 0x08, 0x08, 0x08, 0x10, 0x60, 0x00, 0x00,
	0x00, 0x72, 0x8c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
	0x00, 0x00, 0x00, 0x00, 0x10, 0x28, 0x44, 0x82, 0xfe, 0x82, 0xfe, 0x00, 0x00, 0x00, 0x00, 0x00
};

void bla_drawStr(bla_Window *w, int x, int y, int c, int b, const char *s)
{
	int i, j, k, ch, pt;
	for (i = 0; s[i] != '\0'; i++) {
		ch = s[i];
		if (ch < ' ' || ch > 0x7f) ch = ' ';
		ch = (ch - ' ') * 16;
		for (j = 0; j < 16; j++) {
			pt = fontdata[ch + j];
			for (k = 0; k < 8; k++) {
				if ((pt & 0x80) != 0) {
					bla_setPix(w, x + k, y + j, c);
				} else {
					bla_setPix(w, x + k, y + j, b);
				}
				pt <<= 1;
			}
		}
		x += 8;
	}
	return;
}

void bla_drawStrEx(bla_Window *w, int x, int y, int c, int b, const char *s)
{
	int i, j, k, ch, pt;
	for (i = 0; s[i] != '\0'; i++) {
		ch = s[i];
		if (ch < ' ' || ch > 0x7f) ch = ' ';
		ch = (ch - ' ') * 16;
		for (j = 0; j < 16; j++) {
			pt = fontdata[ch + j];
			for (k = 0; k < 8; k++) {
				if ((pt & 0x80) != 0) {
					bla_setPixEx(w, x + k, y + j, c);
				} else {
					bla_setPixEx(w, x + k, y + j, b);
				}
				pt <<= 1;
			}
		}
		x += 8;
	}
	return;
}

void bla_drawLine(bla_Window *w, int x0, int y0, int x1, int y1, int c)
{
	int x, y, dx, dy, sx, sy, err, e2;
	dx = x1 - x0;
	dy = y1 - y0;
	sx = sy = 1;
	if (dx < 0) { dx *= -1; sx = -1; }
	if (dy < 0) { dy *= -1; sy = -1; }
	err = dx - dy;
	x = x0;
	y = y0;
	for (;;) {
		bla_setPix(w, x, y, c);
		if (x == x1 && y == y1) break;
		e2 = err * 2;
		if (e2 > - dy) {
			err -= dy;
			x += sx;
		}
		if (e2 <   dx) {
			err += dx;
			y += sy;
		}
	}
	return;
}

void bla_drawLineEx(bla_Window *w, int x0, int y0, int x1, int y1, int c)
{
	int x, y, dx, dy, sx, sy, err, e2;
	dx = x1 - x0;
	dy = y1 - y0;
	sx = sy = 1;
	if (dx < 0) { dx *= -1; sx = -1; }
	if (dy < 0) { dy *= -1; sy = -1; }
	err = dx - dy;
	x = x0;
	y = y0;
	for (;;) {
		bla_setPixEx(w, x, y, c);
		if (x == x1 && y == y1) break;
		e2 = err * 2;
		if (e2 > - dy) {
			err -= dy;
			x += sx;
		}
		if (e2 <   dx) {
			err += dx;
			y += sy;
		}
	}
	return;
}

void bla_fillOval(bla_Window *w, int sx, int sy, int x0, int y0, int c)
{
	double dcx, dcy, dcxy, dtx, dty;
	int x, y;
	dcx = 0.5 * (sx - 1);
	dcy = 0.5 * (sy - 1);
	dcxy = (dcx + 0.5) * (dcy + 0.5) - 0.1;
	dcxy *= dcxy;
	for (y = 0; y < sy; y++) {
		dty = (y - dcy) * dcx;
		for (x = 0; x < sx; x++) {
			dtx = (x - dcx) * dcy;
			if (dtx * dtx + dty * dty > dcxy) continue;
				bla_setPix(w, x + x0, y + y0, c);
		}
	}
	return;
}

void bla_fillOvalEx(bla_Window *w, int sx, int sy, int x0, int y0, int c)
{
	double dcx, dcy, dcxy, dtx, dty;
	int x, y;
	dcx = 0.5 * (sx - 1);
	dcy = 0.5 * (sy - 1);
	dcxy = (dcx + 0.5) * (dcy + 0.5) - 0.1;
	dcxy *= dcxy;
	for (y = 0; y < sy; y++) {
		dty = (y - dcy) * dcx;
		for (x = 0; x < sx; x++) {
			dtx = (x - dcx) * dcy;
			if (dtx * dtx + dty * dty > dcxy) continue;
				bla_setPixEx(w, x + x0, y + y0, c);
		}
	}
	return;
}

#define DRAWOVALPARAM	1

void bla_drawOvalEx(bla_Window *w, int sx, int sy, int x0, int y0, int c)
{
	double dcx, dcy, dcxy, dtx, dty, dcx1, dcy1, dcxy1, dtx1, dty1;
	int x, y;
	dcx = 0.5 * (sx - 1);
	dcy = 0.5 * (sy - 1);
	dcxy = (dcx + 0.5) * (dcy + 0.5) - 0.1;
	dcxy *= dcxy;
	dcx1 = 0.5 * (sx - (1 + DRAWOVALPARAM * 2));
	dcy1 = 0.5 * (sy - (1 + DRAWOVALPARAM * 2));
	dcxy1 = (dcx1 + 0.5) * (dcy1 + 0.5) - 0.1;
	dcxy1 *= dcxy1;
	for (y = 0; y < sy; y++) {
		dty  = (y - dcy) * dcx;
		dty1 = (y - dcy) * dcx1;
		for (x = 0; x < sx; x++) {
			dtx = (x - dcx) * dcy;
			dtx1 = (x - dcx) * dcy1;
			if (dtx * dtx + dty * dty > dcxy) continue;
			if (DRAWOVALPARAM <= x && x < sx - DRAWOVALPARAM && DRAWOVALPARAM <= y && y < sy - DRAWOVALPARAM) {
				if (dtx1 * dtx1 + dty1 * dty1 < dcxy1) continue;
			}
			bla_setPixEx(w, x + x0, y + y0, c);
		}
	}
	return;
}

typedef struct bla_Point_ {
	int x, y;
} bla_Point;

void bla_fillEx(bla_Window *w, int x, int y, int c)
{
	int b, sp, sx = w->xsiz, sy = w->ysiz, u, v, *q = w->buf;
	bla_Point *p;
	if (x < 0 || x >= sx || y < 0 || y >= sy || c < 0) return;
	b = q[x + y * sx];
	if (b == c) return;
	p = malloc(sx * sy * sizeof (bla_Point));
	sp = 0; p[sp].x = x; p[sp].y = y; q[x + y * sx] = c;
	do {
		x = p[sp].x;
		y = p[sp].y;
		sp--;
		u = x;     v = y + 1; if (v < sy && q[u + v * sx] == b) { sp++; p[sp].x = u; p[sp].y = v; q[u + v * sx] = c; }
		u = x;     v = y - 1; if (v >= 0 && q[u + v * sx] == b) { sp++; p[sp].x = u; p[sp].y = v; q[u + v * sx] = c; }
		u = x + 1; v = y;     if (u < sx && q[u + v * sx] == b) { sp++; p[sp].x = u; p[sp].y = v; q[u + v * sx] = c; }
		u = x - 1; v = y;     if (u >= 0 && q[u + v * sx] == b) { sp++; p[sp].x = u; p[sp].y = v; q[u + v * sx] = c; }
	} while (sp >= 0);
	free(p);
	return;
}

void bla_waitEx(int msec)
{
	do {
		int i, j = 0;
		for (i = 0; i < bla_TABLESIZ; i++) {
			bla_Window *w = bla_table_w[i];
			if (w == 0) continue;
			if (w->phase == 1) j++;
		}
		if (j == 0) bla_end();
		if (msec > 0) {
			i = msec;
			if (i >= 256)
				i = 128;
			bla_wait(i);
			msec -= i;
		}
	} while (msec > 0);
	return;
}

