#include "bla.h"
#include <stdlib.h>

#define bla_TABLESIZ	16

bla_Window *bla_table_w[bla_TABLESIZ];

static void putKeybuf(bla_Window *w, int c)
{
	if (((w->kbw + 1) & (bla_KEYBUFSIZ - 1)) != w->kbr) {
		w->keybuf[w->kbw] = c;
		w->kbw = (w->kbw + 1) & (bla_KEYBUFSIZ - 1);
	}
	return;
}

// level0

int main(int argc, const char **argv)
{
	int i = bla_main(argc, argv);
	bla_exit(i);
}

static HWND bla_table_hw[bla_TABLESIZ];

static LRESULT CALLBACK WndProc(HWND hw, unsigned int msg, WPARAM wp, LPARAM lp);

static int winthread(bla_Window *w)
{
	WNDCLASSEX wc;
	RECT r;
	int i, x, y;
	MSG msg;

	x = w->xsiz;
	y = w->ysiz;

	wc.cbSize = sizeof (WNDCLASSEX);
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = w->hInst;
	wc.hIcon = (HICON) LoadImage(NULL, MAKEINTRESOURCE(IDI_APPLICATION),
		IMAGE_ICON, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
	wc.hIconSm = wc.hIcon;
	wc.hCursor = (HCURSOR)LoadImage(NULL, MAKEINTRESOURCE(IDC_ARROW),
		IMAGE_CURSOR, 0, 0, LR_DEFAULTSIZE | LR_SHARED);
	wc.hbrBackground = (HBRUSH) COLOR_APPWORKSPACE;
	wc.lpszMenuName = NULL;
	wc.lpszClassName = w->title;
	if (RegisterClassEx(&wc) == 0)
		return 1;
	r.left = 0;
	r.top = 0;
	r.right = x;
	r.bottom = y;
	AdjustWindowRect(&r, WS_OVERLAPPEDWINDOW, FALSE);
	x = r.right - r.left;
	y = r.bottom - r.top;

	w->hWnd = CreateWindowA(wc.lpszClassName, w->title, WS_OVERLAPPEDWINDOW,
		CW_USEDEFAULT, CW_USEDEFAULT, x, y, NULL, NULL,	w->hInst, NULL);
	if (w->hWnd == NULL)
		return 1;
	bla_table_hw[w->table_idx] = w->hWnd;
	ShowWindow(w->hWnd, SW_SHOW);
	UpdateWindow(w->hWnd);

	for (;;) {
		i = GetMessage(&msg, NULL, 0, 0);
		if (i == 0 || i == -1)	/* G[͏IbZ[W */
			break;
		/* ̂ق͂Ƃ肠ftHg */
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	// ̃^C~OfreeĂ͂Ȃ.
	UnregisterClass(w->title, w->hInst);
	w->phase = 2;
	return 0;
}

static int getKeyState0()
{
	int i = 0;
	if ((GetKeyState(VK_LSHIFT)   & (1 << 15)) != 0) i |= 1 << 16;
	if ((GetKeyState(VK_NUMLOCK)  & (1 <<  0)) != 0) i |= 1 << 22;
	if ((GetKeyState(VK_CAPITAL)  & (1 <<  0)) != 0) i |= 1 << 23;
	if ((GetKeyState(VK_RSHIFT)   & (1 << 15)) != 0) i |= 1 << 24;
	return i;	
}

static int getKeyState1()
{
	int j = 0;
	if ((GetKeyState(VK_LCONTROL) & (1 << 15)) != 0) j |= 1 << 17;
	if ((GetKeyState(VK_LMENU)    & (1 << 15)) != 0) j |= 1 << 18;
	if ((GetKeyState(VK_RCONTROL) & (1 << 15)) != 0) j |= 1 << 25;
	if ((GetKeyState(VK_RMENU)    & (1 << 15)) != 0) j |= 1 << 26;
	return j;	
}

static LRESULT CALLBACK WndProc(HWND hw, unsigned int msg, WPARAM wp, LPARAM lp)
{
	bla_Window *w;
	int i, j;
	for (i = 0; i < bla_TABLESIZ; i++) {
		if (bla_table_hw[i] == hw)
			break;
	}
	if (i >= bla_TABLESIZ)
		return DefWindowProc(hw, msg, wp, lp);
	w = bla_table_w[i];
	if (msg == WM_PAINT) {
		PAINTSTRUCT ps;
		HDC hdc = BeginPaint(hw, &ps);
		SetDIBitsToDevice(hdc, 0, 0, w->xsiz, w->ysiz,
			0, 0, 0, w->ysiz, w->buf, &w->bmi, DIB_RGB_COLORS);
		EndPaint(hw, &ps);
		return 0;
	}
	if (msg == WM_DESTROY) {
		PostQuitMessage(0); // ȂƃXbhIȂ.
		return 0;
	}
	if (msg == WM_KEYDOWN || msg == WM_SYSKEYDOWN) {
		i = -1;
		if (wp == VK_RETURN)	i = bla_KEY_ENTER;
		if (wp == VK_ESCAPE)	i = bla_KEY_ESC;
		if (wp == VK_BACK)		i = bla_KEY_BACKSPACE;
		if (wp == VK_TAB)		i = bla_KEY_TAB;
		if (wp == VK_PRIOR)		i = bla_KEY_PAGEUP;
		if (wp == VK_NEXT)		i = bla_KEY_PAGEDWN;
		if (wp == VK_END)		i = bla_KEY_END;
		if (wp == VK_HOME)		i = bla_KEY_HOME;
		if (wp == VK_LEFT)		i = bla_KEY_LEFT;
		if (wp == VK_RIGHT)		i = bla_KEY_RIGHT;
		if (wp == VK_UP)		i = bla_KEY_UP;
		if (wp == VK_DOWN)		i = bla_KEY_DOWN;
		if (wp == VK_INSERT)	i = bla_KEY_INS;
		if (wp == VK_DELETE)	i = bla_KEY_DEL;
		j = getKeyState1();
		if (j != 0 && ' ' <= wp && wp <= 0x7e)
			i = wp;	// CtrlAltƉĂꍇ́Aput.
		i |= getKeyState0();
		if (i != -1) {
			putKeybuf(w, i | j);
			return 0;
		}
	}
//	if (msg == WM_KEYUP) { i = 0xfff; }
	if (msg == WM_CHAR) {
		if (' ' <= wp && wp <= 0x7e) {
			i = wp | getKeyState0();
			j = getKeyState1();
			putKeybuf(w, i | j);
			return 0;
		}
	}
	return DefWindowProc(hw, msg, wp, lp);
}

bla_Window *bla_openWin(int x, int y, const char *t)
{
	int i, j;
	for (i = 0; i < bla_TABLESIZ; i++) {
		if (bla_table_w[i] == 0) break;
	}
	if (i >= bla_TABLESIZ) return 0;

	bla_Window *w = malloc(sizeof (bla_Window));
	bla_table_w[i] = w;
	w->table_idx = i;
	w->title[0] = '\0';
	if (t != 0) {
		strncpy(w->title, t, 63);
		w->title[63] = '\0';
	}
	if (w->title[0] == '\0') {
		w->title[0] = ' ';
		w->title[1] = '\0';
	}
	w->kbw = w->kbr = 0;
	w->phase = 1;
	w->xsiz = x;
	w->ysiz = y;
	w->buf = malloc(x * y * sizeof (int));
	w->lastFlush = clock();
	w->mode = bla_MODE_SET;
#if 0
	w->cx = pwtp->cy = 0;
	w->col = 0xffffff;
	w->bcol = 0;
	w->gets_ph = 0;
#endif
	bla_fillRect(w, x, y, 0, 0, 0);

	w->bmi.bmiHeader.biSize = sizeof (BITMAPINFOHEADER);
	w->bmi.bmiHeader.biWidth = x;
	w->bmi.bmiHeader.biHeight = - y;
	w->bmi.bmiHeader.biPlanes = 1;
	w->bmi.bmiHeader.biBitCount = 32;
	w->bmi.bmiHeader.biCompression = BI_RGB;
	CreateThread(NULL, 0, (void *) &winthread, (void *) w, 0, (void *) &i);
	return w;
}

void bla_flushAll(bla_Window *w)
{
	if (w->phase == 1) {
		InvalidateRect(w->hWnd, NULL, FALSE);
		UpdateWindow(w->hWnd);
		w->lastFlush = clock();
	}
	return;
}

void bla_wait(int msec)
{
	Sleep(msec);
	return;
}

void bla_closeWin(bla_Window *w)
{
	if (w->phase == 1) {
		PostMessage(w->hWnd, WM_CLOSE, 0, 0);
		while (w->phase == 1)
			bla_wait(128);
	}

	free(w->buf);
	bla_table_w[w->table_idx] = 0;
	free(w);
	return;
}

void bla_exit(int c) { exit(c); }

