#include "tjlib.c"

unsigned char txt[10000], t0[10000], jck[10000];

int ssc(const unsigned char *s, const unsigned char *t)
{
	const unsigned char *u = strchr(t, ' ');
	if (u == 0) return 1;
	return strncmp(s, t, u - t + 1);
}

int mssc(const unsigned char *s, const unsigned char *t)
{
	int i;
	for (i = 0; ; i++) {
		const unsigned char *u = strchr(t, ' ');
		if (u == 0) return -1;
		if (strncmp(s, t, u - t + 1) == 0) return i;
		t = u + 1;
	}
}

int putJck(unsigned char *d, const unsigned char *s, int *pcf, const char *f, ...)
{
	int i = 0, j = 0, k;
	const unsigned char *t;
	va_list ap;
	va_start(ap, f);
	while (f[i] != 0) {
		if (f[i] != '%')
			d[j++] = f[i++];
		else {
			t = 0;
			if (f[i + 1] == 't')	// token.
				t = va_arg(ap, const unsigned char *);
			if ('0' <= f[i + 1] && f[i + 1] <= '9')
				t = &s[pcf[f[i + 1] - '0']];
			if (t != 0) {
				if (f[i + 2] == '!') {
					i++;
					k = mssc(t, "== != >= <= > < ");
					if (k >= 0)
						t = &"!= == <  >  <= >= "[k * 3];
				}
				k = 0;
				while (t[k] != ' ')
					d[j++] = t[k++];
			}
			if (f[i + 1] == 'x')
				j += sprintf(&d[j], "%x", va_arg(ap, int));
			if (f[i + 1] == '%')
				d[j++] = '%';
			i += 2;
		}
	}
	va_end(ap);
	return j;
}

int nextToken(const unsigned char *s, int i)
{
	if (s[i] != 0) {
		do {
			i++;
		} while (s[i] != ' ' && s[i] != 0);
		if (s[i] == ' ') i++;
	}
	return i;
}

void sub_print(int i)
{
	printf("%d\n", i);
}

void sub_time()
{
	printf("time=%.3f[sec]\n", clock() / (double) CLOCKS_PER_SEC);
}

int jitL1(unsigned char *s, unsigned char *d, int siz1)
{
	int i, pc0, pc = 0, qc = 0, cbs[99], cbsp = 0;
	cbs[0] = 0;
	qc += putJck(&d[qc], s, 0, "$startup ; ");
	for (;;) {
		pc0 = pc;
		if (qc + 64 >= siz1) { puts("jitL1: output error");	exit(1); } // obt@̕s.
		if (s[pc] == 0)	// t@CI[.
			break;
		i = mssc(&s[pc], "int register label option undef lundef ");
		if (i >= 0) {
			static char *t[6] = { "$local $int32 ", "$reg ", "$reserve ", "$option ", "$dev ", "$del " };
			qc += putJck(&d[qc], s, 0, t[i]);
			for (pc = nextToken(s, pc); s[pc] != 0 && ssc(&s[pc], "; ") != 0; pc = nextToken(s, pc)) {
				if (ssc(&s[pc], ", ") == 0) continue;
				qc += putJck(&d[qc], s, 0, "%t ", &s[pc]);
			}
			qc += putJck(&d[qc], s, 0, "; ");
			pc += 2;	// skip ;.
		} else {
			static const char *phrase[] = {
				"0@ ; 									00 ",
				"0@ @ = @ ; 							00 %0 = %1 ; ",
				"0@ @ = @ @ @ ; 						00 %0 = %1 %2 %3 ; ",
				"0@ return ; 							00 $return ; ",
				"0@ return @ ; 							00 $return %0 ; ",
				"0@ time ; 								ca $call 0x%x ; ",
				"0@ print @ ; 							cb $#0 = %0 ; $call 0x%x ; ",
				"0@ @ : 								00 $label %0 ; ",
				"0@ goto @ ; 							00 $goto %0 ; ",
				"0@ break ; 							00 $goto .break ; ",
				"0@ continue ; 							00 $goto .continue ; ",
				"0@ continue0 ; 						00 $goto .continue0 ; ",
				"0@ if ( @ @ @ ) goto @ ; 				00 $if %0 %1 %2 $goto %3 ; ",
				"0@ if ( @ @ @ ) break ; 				00 $if %0 %1 %2 $goto .break ; ",
				"0@ if ( @ @ @ ) continue ; 			00 $if %0 %1 %2 $goto .continue ; ",
				"0@ if ( @ @ @ ) continue0 ; 			00 $if %0 %1 %2 $goto .continue0 ; ",
				"0@ if ( @ @ @ ) { 						01 $reserve .else .fi ; $if %0 %1! %2 $goto .else ; ",
				"1@ } else if ( @ @ @ ) { 				01 $goto .fi ; $label .else ; $del .else ; $reserve .else ; $if %0 %1! %2 $goto .else ; ",
				"1@ } else { 							-2 $goto .fi ; $label .else ; ",
				"1@ } 									-0 $label .else ; $del .else .fi ; ",
				"2@ } 									-0 $label .fi ; $del .else .fi ; ",
				"0@ do { 								03 $reserve .break .continue ; $label .continue0 ; ",
				"3@ } while ( @ @ @ ) ; 				-0 $label .continue ; $if %0 %1 %2 $goto .continue0 ; $label .break ; $del .continue0 .break .continue ; ",
				"0@ while ( @ @ @ ) { 					04 $reserve .break ; $label .continue ; $if %0 %1! %2 $goto .break ; $label .continue0 ; ",
				"4@ } 									-0 $if %0 %1 %2 $goto .continue0 ; $label .break ; $del .continue0 .break .continue ; ",
				"0@ @ ++ ; 								00 %0 = %0 + 1 ; ",
				"0@ @ -- ; 								00 %0 = %0 - 1 ; ",
				"0@ @ += @ ; 							00 %0 = %0 + %1 ; ",
				"0@ @ -= @ ; 							00 %0 = %0 - %1 ; ",
				"0@ @ *= @ ; 							00 %0 = %0 * %1 ; ",
				"0@ @ /= @ ; 							00 %0 = %0 / %1 ; ",
				"0@ @ %= @ ; 							00 %0 = %0 %% %1 ; ",
				"0@ for ( @ = @ ; @ @ @ ; @ ++ ) { 		05 %0 = %1 ; $reserve .break ; $label .continue ; $if %2 %3! %4 $goto .break ; $label .continue0 ; ",
				"5@ } 									-0 $label .continue ; %5 = %5 + 1 ; $if %2 %3 %4 $goto .continue0 ; $label .break ; $del .continue0 .break .continue ; ",
				"0@ for ( @ = @ ; @ @ @ ; @ -- ) { 		06 %0 = %1 ; $reserve .break ; $label .continue ; $if %2 %3! %4 $goto .break ; $label .continue0 ; ",
				"6@ } 									-0 $label .continue ; %5 = %5 - 1 ; $if %2 %3 %4 $goto .continue0 ; $label .break ; $del .continue0 .break .continue ; ",
				"0@ for ( @ = @ ; @ @ @ ; @ += @ ) { 	07 %0 = %1 ; $reserve .break ; $label .continue ; $if %2 %3! %4 $goto .break ; $label .continue0 ; ",
				"7@ } 									-0 $label .continue ; %5 = %5 + %6 ; $if %2 %3 %4 $goto .continue0 ; $label .break ; $del .continue0 .break .continue ; ",
				"0@ for ( @ = @ ; @ @ @ ; @ -= @ ) { 	08 %0 = %1 ; $reserve .break ; $label .continue ; $if %2 %3! %4 $goto .break ; $label .continue0 ; ",
				"8@ } 									-0 $label .continue ; %5 = %5 - %6 ; $if %2 %3 %4 $goto .continue0 ; $label .break ; $del .continue0 .break .continue ; ",
				"0@ for ( @ = @ ; @ @ @ ; @ = @ @ @ ) { 09 %0 = %1 ; $reserve .break ; $label .continue ; $if %2 %3! %4 $goto .break ; $label .continue0 ; ",
				"9@ } 									-0 $label .continue ; %5 = %6 %7 %8 ; $if %2 %3 %4 $goto .continue0 ; $label .break ; $del .continue0 .break .continue ; ",
				0
			};
			for (i = 0; phrase[i] != 0; i++) {
				const char *ph = phrase[i];
				int j = 3, k = pc, kb[9], kbi = 0;
				if (ph[0] != '0' && cbs[cbsp] != ph[0]) continue;
				while (ph[j] > ' ') {
					if (ph[j] == ph[1]) {
						kb[kbi++] = k;
					} else if (ssc(&ph[j], &s[k]) != 0)
						break;
					j = nextToken(ph, j);
					k = nextToken(s,  k);
				}
				if (ph[j] > ' ') continue;
				pc = k;
				while (ph[j] <= ' ')
					j++;
				if (ph[j] == '-') {
					cbsp--;
					if (cbs[cbsp + 1] >= '4') {
						for (k = 8; k >= 0; k--)
							kb[k] = cbs[cbsp--];
					}
				}
				if ('1' <= ph[j + 1] && ph[j + 1] <= '9') {
					if (ph[j + 1] >= '4') {
						for (k = 0; k <= 8; k++)
							cbs[++cbsp] = kb[k];
					}
					cbs[++cbsp] = ph[j + 1];
				}
				k = 0;
				if (ph[j] == 'c') {
					static void *t[] = { sub_time, sub_print };
					k = (int) t[ph[j + 1] - 'a'];
				}
				qc += putJck(&d[qc], s, kb, &ph[j + 3], k);
				break;
			}
			if (phrase[i] == 0) goto err;
		}
	}
	qc += putJck(&d[qc], s, 0, "$return ; ");
	d[qc] = 0;
	return qc;
err:
	printf("jitL1: syntax error : %.20s\n", &s[pc0]);
	exit(1);
}

int main(int argc, const char **argv)
{
	unsigned char *code = mallocRWX(1024 * 1024);
	int i, j, pc0, pc1, pc2;
	void (*func)();	// func͊֐ւ̃|C^^̕ϐ.
	loadText(argc, argv, txt, 10000);
	lexer(txt, t0, 10000, 0);
	jitL1(t0 + 1, jck, 10000);
	if (argc >= 3 && argv[2][0] == 'j') { puts(jck); exit(0); }	// dump-jck.
	i = jck0(jck, code, 1024 * 1024, &pc0, &pc1, &pc2);
	if (i < 0) {
		static char *errmsg[] = { "OUTPUT", "SYNTAX", 0, "OVRDEF", "UNDEF", "INTERNAL" };
		printf("jck0: ERR_%s: '%.*s'    [pos] %.40s\n", errmsg[-1 - i], (unsigned char *) strchr(&jck[pc1], ' ') - &jck[pc1], &jck[pc1], &jck[pc0]);
		exit(1);
	}
	if (argc >= 3 && argv[2][0] == 'b') { for (j = 0; j < i; j++) printf("%02x ", code[j]); printf("\ntotal=%d[bytes]\n", i); exit(0); }	// dump-binary.
	func = (void *) code;
	func();
	exit(0);
}
