#include "tjlib.c"
#include "jcklib.c"

unsigned char txt[10000], t0[10000], jck1t_[10000], jck0t_[10000], *jck1t = jck1t_, *jck0t = jck0t_;

int putJck(unsigned char *d, const unsigned char *s, int *pcf, const char *f, ...);

// staticToken

const unsigned char *staticToken0(const unsigned char *s)
{
	static unsigned char buf[4096];
	unsigned char *p = buf;
	int i;
	while (*p != 0) {
		if (ssc(s, p) == 0)
			return p;
		p = strchr(p, ' ') + 1;
	}
	for (i = 0; s[i] != ' '; i++)
		p[i] = s[i];
	p[i] = ' ';
	return p;
}

const unsigned char *staticToken(const char *f, ...)
{
	unsigned char buf[64];
	va_list ap;
	va_start(ap, f);
	vPutJck_(buf, 0, f, ap);
	va_end(ap);
	return staticToken0(buf);
}

// ^̊Ǘ.

const unsigned char *vnam[4096], *vtyp[4096];
int vtp = 0;

void setTyp(const unsigned char *n, const unsigned char *t)
{
	int i = vtp++;
	vnam[i] = n;
	vtyp[i] = t;
}

int searchTyp(const unsigned char *n)
{
	int i;
	for (i = vtp - 1; i >= 0; i--)
		if (ssc(vnam[i], n) == 0) break;
	return i;
}

void delTyp(const unsigned char *n)
{
	int i = searchTyp(n);
	if (i >= 0)
		vnam[i] = "$deleted ";
}

int sizTyp(const unsigned char *t)
{
	if (ssc(t, "int32 ") == 0) return 4;
	if (ssc(t, "ptr ") == 0) return 4;
	fprintf(stderr, "sizTyp: unknown '%.10s'\n", t);
	exit(1);
}

int untTyp(const unsigned char *t)
{
	if (t[0] == '0') return 1;
	if (t[0] != '1') return sizTyp("ptr ");
	return sizTyp(&t[2]);
}

int cmpTyp(const unsigned char *ty, const unsigned char *ety)
{
	if (ssc(ty, ety) == 0) return 0;
	if (ssc(ety, "* ") == 0) return 0;
	if (ssc(ety, "1+: ") == 0 && '1' <= ty[0] && ty[0] <= '9' && ty[1] == ':') return 0;
	return 1;
}

// putJck֌W.

typedef struct OpWork_ {
	const unsigned char *s, *tm[99], *tn[99], *ty[99], *op[99];
	unsigned char buf[65536];
	int pc, qc, tmp, opp, pr[99], nest;
} OpWork;

typedef int (*OpFunc)(OpWork *, void *);

typedef struct Op1_ {	// ++ -- (svf)	Zq̓obt@ɂ܂Ȃ.
	const unsigned char *op0, *ty0;
	OpFunc f;
	void *fw;
} Op1;

typedef struct Op2_ {	// . ->		(svf)	Zq̓obt@ɂ܂Ȃ.

} Op2;

typedef struct Op3_ {	// ( [	(svf)	Zq̓obt@ɂ܂.
	const unsigned char *op0, *op1, *ty0;
	int pr, addNest;
} Op3;

// Op4 : ( [	(svfȂ)	Zq̓obt@ɂ܂.
// Op5 : POuZq. (E獶)

typedef struct Op6_ {	// ʓ񍀉Zq. (E or E獶) || ) ] , ;	JbR.
	const unsigned char *op0, *ty0;
	char nest0fin;
	int pr0, pr1, tyl;
	OpFunc f, g;
	void *fw, *gw;
} Op6;

Op1 op1Table[9];
Op3 op3Table[9], op4Table[9], op5Table[19];
Op6 op6Table[99];

void opPush(OpWork *w, Op3 *op)
{
	w->tm[w->tmp] = op->op1;
	w->tn[w->tmp] = 0;
	w->ty[w->tmp] = "op ";
	w->tmp++;
	w->op[w->opp] = op->op1;
	w->pr[w->opp] = op->pr;
	w->opp++;
}

#define MX 0x7fffffff

int opExec(OpWork *w)
{
	int i, j, k;
	for (i = 0; op6Table[i].op0 != 0; i++) {
		if (ssc(w->op[w->opp - 1], op6Table[i].op0) == 0 && w->tmp >= op6Table[i].tyl) {
			for (j = k = 0; j < op6Table[i].tyl; j++) {
				if (cmpTyp(w->ty[w->tmp - op6Table[i].tyl + j], &op6Table[i].ty0[k]) != 0)
					break;
				k = nextToken(op6Table[i].ty0, k);
			}
			if (j >= op6Table[i].tyl) {
				if ((op6Table[i].f)(w, op6Table[i].fw) == 0)
					return 0;
			}
		}
	}
	return 1;
}

int putJckSubExp(unsigned char *d, int i0, int i1, const unsigned char *s, int t, char c)
{
	int i, j;
	OpWork w;
	w.s = s;
	w.pc = t;
	w.qc = 0;
	w.tmp = 0;
	w.opp = 0;
	w.nest = 0;
	for (;;) {
		while (w.opp > 0 && w.pr[w.opp - 1] == MX)
			opExec(&w);
		if (w.tmp > 0 && '0' <= w.ty[w.tmp - 1][0] && w.ty[w.tmp - 1][0] <= '9') {
			for (i = 0; op1Table[i].op0 != 0; i++) {
				if (ssc(&s[w.pc], op1Table[i].op0) == 0 && cmpTyp(w.ty[w.tmp - 1], op1Table[i].ty0) == 0) {
					if ((op1Table[i].f)(&w, op1Table[i].fw) == 0)
						goto next;
				}
			}
			for (i = 0; op3Table[i].op0 != 0; i++) {
				if (ssc(&s[w.pc], op3Table[i].op0) == 0 && cmpTyp(w.ty[w.tmp - 1], op3Table[i].ty0) == 0) {
					opPush(&w, &op3Table[i]);
					w.nest += op3Table[i].addNest;
					goto next;
				}
			}
		} else {
			for (i = 0; op5Table[i].op0 != 0; i++) {
				if (ssc(&s[w.pc], op5Table[i].op0) == 0) {
					opPush(&w, &op5Table[i]);
					w.nest += op5Table[i].addNest;
					goto next;
				}
			}
			for (i = 0; op4Table[i].op0 != 0; i++) {
				if (ssc(&s[w.pc], op4Table[i].op0) == 0) {
					opPush(&w, &op4Table[i]);
					w.nest += op4Table[i].addNest;
					goto next;
				}
			}
		}
		for (i = 0; op6Table[i].op0 != 0; i++) {
			if (ssc(&s[w.pc], op6Table[i].op0) == 0)
				break;
		}
		if (op6Table[i].op0 != 0) {
			if (w.opp > 0 && (w.pr[w.opp - 1] > op6Table[i].pr0 || (w.pr[w.opp - 1] == op6Table[i].pr0 && op6Table[i].pr0 % 2 != 0))) {
				if (opExec(&w) == 0) goto next1;
				fprintf(stderr, "putJckSubExp: undefined operator : '%.10s'\n", w.op[w.opp - 1]);
				exit(1);
			}
			if (op6Table[i].nest0fin != 0 && w.nest == 0)
				break;
			if (op6Table[i].g == 0 || (op6Table[i].g)(&w, op6Table[i].g) != 0) {
				w.tm[w.tmp] = op6Table[i].op0;
				w.tn[w.tmp] = 0;
				w.ty[w.tmp] = "op ";
				w.tmp++;
				w.op[w.opp] = op6Table[i].op0;
				w.pr[w.opp] = op6Table[i].pr1;
				w.opp++;
			}
			goto next;
		}
		if (testConstInt(&s[w.pc]) != 0) {
			w.tm[w.tmp] = &s[w.pc];
			w.tn[w.tmp] = 0;
			w.ty[w.tmp] = "0:int32 ";
			w.tmp++;
			goto next;
		}
		i = searchTyp(&s[w.pc]);
		if (i >= 0) {
			w.tm[w.tmp] = &s[w.pc];
			w.tn[w.tmp] = 0;
			w.ty[w.tmp] = vtyp[i];
			w.tmp++;
			goto next;
		}
		fprintf(stderr, "putJckSubExp: undefined symbol : '%.10s'\n", &s[w.pc]);
		exit(1);
next:
		w.pc = nextToken(s, w.pc);
next1:
		;
	}
	for (j = i1 - 1; j >= i0; j--)
		d[j + w.qc] = d[j];
	for (j = 0; j < w.qc; j++)
		d[i0 + j] = w.buf[j];
	w.qc += i1;
	if (c == 'e' && w.tmp != 1) { /* printf("tmp=%d\n", tmp); */ fprintf(stderr, "%.10s\n%.10s\n", w.tm[0], w.tm[1]); exit(1); }
	if (c == 'e')
		w.qc += putJck_(&d[w.qc], 0, "%t", w.tm[0]);
	return w.qc - i1;
}

int itmp = 0;

const unsigned char *newTmpBuf(OpWork *w, const unsigned char *ty)
{
	const unsigned char *r;
	if (ssc(ty, "0:int32 ") == 0)
		w->qc += putJck_(&w->buf[w->qc], 0, "$temp $int32 ");
	else if (cmpTyp(ty, "1+: ") == 0)
		w->qc += putJck_(&w->buf[w->qc], 0, "$temp $int32 ");	// ptr
	r = &w->buf[w->qc];
	w->qc += putJck_(&w->buf[w->qc], 0, "$t%x ; ", itmp++);
	return r;
}

static int pj_sub1(void **sw, unsigned char *d, const char *f, int *pi, va_list *pap)
{
	int i = *pi, j = 0, k, qc0;
	OpWork *w = sw[1];
	va_list ap = *pap;
	if (f[i + 1] == 'm') {
		k = f[i + 2] - '0';
		i += 3;
		j = putJck_(d, 0, "%t", w->tm[w->tmp - k]);
	} else if (f[i + 1] == 'M') {
		k = f[i + 2] - '0';
		i += 3;
		if (w->tn[w->tmp - k] != 0) {
			qc0 = w->qc;
			w->qc = d - w->buf;
			sw[2] = (void *) w->tn[w->tmp - k];
			sw[3] = (void *) newTmpBuf(w, w->ty[w->tmp - k]);
			w->qc += putJck_(&w->buf[w->qc], 0, "%t", sw[3]);
			j = w->qc - qc0;
			w->qc = qc0;
		} else
			j = putJck_(d, 0, "%t", w->tm[w->tmp - k]);
	} else
		putJck_sub0(sw, d, f, pi, pap);
	*pi = i;
	*pap = ap;
	return j;
}

void opPutJck1Buf(OpWork *w, const char *f, ...)
{
	void *sw[4];
	va_list ap;
	va_start(ap, f);
	sw[0] = pj_sub1;
	sw[1] = w;
	sw[2] = 0;
	w->qc += vPutJck_(&w->buf[w->qc], sw, f, ap);
	if (sw[2] != 0)
		opPutJck1Buf(w, "* %t = %t ; ", sw[2], sw[3]);
	va_end(ap);
}

int opFncErr(OpWork *w, void *fw)
{
	(void) w;
	fprintf(stderr, "opFncErr: %s\n", (const char *) fw);
	exit(1);
}

void opInit1(const unsigned char *op0, const unsigned char *ty0, OpFunc f, void *fw)
{
	int i;
	for (i = 0; op1Table[i].op0 != 0; i++);
	op1Table[i].op0 = op0;
	op1Table[i].ty0 = ty0;
	op1Table[i].f   = f;
	op1Table[i].fw  = fw;
}

void opInit3(const unsigned char *op0, const unsigned char *op1, const unsigned char *ty0, int addNest)
{
	int i;
	for (i = 0; op3Table[i].op0 != 0; i++);
	op3Table[i].op0 = op0;
	op3Table[i].op1 = op1;
	op3Table[i].ty0 = ty0;
	op3Table[i].pr  = 0;
	op3Table[i].addNest = addNest;
}

void opInit4(const unsigned char *op0, const unsigned char *op1, int addNest)
{
	int i;
	for (i = 0; op4Table[i].op0 != 0; i++);
	op4Table[i].op0 = op0;
	op4Table[i].op1 = op1;
	op4Table[i].pr  = 0;
	op4Table[i].addNest = addNest;
}

void opInit5(const unsigned char *op0, const unsigned char *op1, int addNest)
{
	int i;
	for (i = 0; op5Table[i].op0 != 0; i++);
	op5Table[i].op0 = op0;
	op5Table[i].op1 = op1;
	op5Table[i].pr  = 98;
	op5Table[i].addNest = addNest;
}

void opInit6(const unsigned char *op0, int pr0, int pr1, int tyl, const unsigned char *ty0, int nest0fin, OpFunc f, void *fw, OpFunc g, void *gw)
{
	int i;
	for (i = 0; op6Table[i].op0 != 0; i++);
	op6Table[i].op0 = op0;
	op6Table[i].pr0 = pr0;
	op6Table[i].pr1 = pr1;
	op6Table[i].tyl = tyl;
	op6Table[i].ty0 = ty0;
	op6Table[i].nest0fin = nest0fin;
	op6Table[i].f   = f;
	op6Table[i].fw  = fw;
	op6Table[i].g   = g;
	op6Table[i].gw  = gw;
}

// PuZq ++ --
int op1f00(OpWork *w, void *fw)
{
	const unsigned char *t = newTmpBuf(w, w->ty[w->tmp - 1]);
	opPutJck1Buf(w, "%t = %m1 ; ", t);	// "%M"͖`ɂׂȂ̂ŉLƂ̓}[WłȂ.
	opPutJck1Buf(w, "%M1 = %m1 %t 0x%x ; ", fw, untTyp(w->ty[w->tmp - 1]));
	w->tm[w->tmp - 1] = t;
	w->tn[w->tmp - 1] = 0;	// ty͂̂܂.
	return 0;
}

// PZq =
int op6f00(OpWork *w, void *fw)
{
	(void) fw;
	if (ssc(w->ty[w->tmp - 3], w->ty[w->tmp - 1]) == 0) {
		opPutJck1Buf(w, "%M3 = %m1 ; ");
		w->tmp -= 2;
		w->opp--;
		return 0;
	}
	return 1;
}

// ZZq += -=
int op6f01(OpWork *w, void *fw)
{
	if (mssc(fw, "+ - ") >= 0 && ssc(w->ty[w->tmp - 1], "0:int32 ") == 0) {
		const unsigned char *t = newTmpBuf(w, "0:int32 ");
		opPutJck1Buf(w, "%t = %m1 * 0x%x ; ", t, untTyp(w->ty[w->tmp - 3]));
		w->tm[w->tmp - 1] = t;
	}
	opPutJck1Buf(w, "%M3 = %m3 %t %m1 ; ", fw);
	w->tmp -= 2;
	w->opp--;
	return 0;
}

// ʓIȓ񍀉Zq + - * / (^p)
int op6f02(OpWork *w, void *fw)
{
	const unsigned char *t = newTmpBuf(w, w->ty[w->tmp - 1]);
	opPutJck1Buf(w, "%t = %m3 %t %m1 ; ", t, fw);
	w->tmp -= 2;
	w->opp--;
	w->tn[w->tmp - 1] = 0;	// ty͂̂܂.
	w->tm[w->tmp - 1] = t;
	return 0;
}

// for .++ .--
int op6f03(OpWork *w, void *fw)
{
	opPutJck1Buf(w, "%M1 = %m1 %t 0x%x ; ", fw, untTyp(w->ty[w->tmp - 1]));
	w->tm[w->tmp - 2] = w->tm[w->tmp - 1];
	w->tn[w->tmp - 2] = w->tn[w->tmp - 1];
	w->ty[w->tmp - 2] = w->ty[w->tmp - 1];
	w->tmp--;
	w->opp--;
	return 0;
}

// for .+
int op6f04(OpWork *w, void *fw)
{
	(void) fw;
	w->tm[w->tmp - 2] = w->tm[w->tmp - 1];
	w->tn[w->tmp - 2] = w->tn[w->tmp - 1];
	w->ty[w->tmp - 2] = w->ty[w->tmp - 1];
	w->tmp--;
	w->opp--;
	return 0;
}

// for .- .~
int op6f05(OpWork *w, void *fw)
{
	const unsigned char *t = newTmpBuf(w, w->ty[w->tmp - 1]);
	opPutJck1Buf(w, "%t = %t %m1 ; ", t, fw);
	w->tm[w->tmp - 2] = t;
	w->tn[w->tmp - 2] = 0;
	w->ty[w->tmp - 2] = w->ty[w->tmp - 1];
	w->tmp--;
	w->opp--;
	return 0;
}

// for .&
int op6f06(OpWork *w, void *fw)
{
	(void) fw;
	unsigned char s[64];
	if (w->tn[w->tmp - 1] == 0) {
		const unsigned char *t = newTmpBuf(w, w->ty[w->tmp - 1]);
		opPutJck1Buf(w, "%t = & %m1 ; ", t);
		w->tm[w->tmp - 2] = t;
	} else
		w->tm[w->tmp - 2] = w->tn[w->tmp - 1];
	w->tn[w->tmp - 2] = 0;
	putJck_(s, 0, "%t ", w->ty[w->tmp - 1]);
	s[0]++;
	w->ty[w->tmp - 2] = staticToken(s);
	w->tmp--;
	w->opp--;
	return 0;
}

// for .*
int op6f07(OpWork *w, void *fw)
{
	(void) fw;
	unsigned char s[64];
	const unsigned char *t;
	putJck_(s, 0, "%t ", w->ty[w->tmp - 1]);
	s[0]--;
	t = newTmpBuf(w, s);
	opPutJck1Buf(w, "%t = * %m1 ; ", t);
	w->tm[w->tmp - 2] = t;
	w->tn[w->tmp - 2] = w->tm[w->tmp - 1];
	w->ty[w->tmp - 2] = staticToken(s);
	w->tmp--;
	w->opp--;
	return 0;
}

// for ]
int op6f08(OpWork *w, void *fw)
{
	(void) fw;
	if (ssc(w->op[w->opp - 2], "[ ") == 0) {
		const unsigned char *t = newTmpBuf(w, w->ty[w->tmp - 4]);
		const unsigned char *u = newTmpBuf(w, "0:int32 "), *v;
		unsigned char s[64];
		w->nest--;
		putJck_(s, 0, "%t ", w->ty[w->tmp - 4]);
		s[0]--;
		v = newTmpBuf(w, s);
		opPutJck1Buf(w, "%t = %m2 * 0x%x ; %t = %m4 + %t ; %t = * %t ; ", u, untTyp(w->ty[w->tmp - 4]), t, u, v, t);
		w->tm[w->tmp - 4] = v;
		w->tn[w->tmp - 4] = t;
		w->ty[w->tmp - 4] = staticToken(s);
		w->tmp -= 3;
		w->opp -= 2;
		return 0;
	}
	return 1;
}

// |C^ɑ΂Z + -
int op6f09(OpWork *w, void *fw)
{
	const unsigned char *t = newTmpBuf(w, w->ty[w->tmp - 3]);
	const unsigned char *u = newTmpBuf(w, "0:int32 ");
	opPutJck1Buf(w, "%t = %m1 * 0x%x ; %t = %m3 %t %t ; ", u, untTyp(w->ty[w->tmp - 3]), t, fw, u);
	w->tm[w->tmp - 3] = t;
	w->tn[w->tmp - 3] = 0;	// ty͂̂܂.
	w->tmp -= 2;
	w->opp--;
	return 0;
}

// .( JbR.
int op6f0a(OpWork *w, void *fw)
{
	(void) fw;
	if (ssc(w->op[w->opp - 2], ".( ") == 0) {
		w->nest--;
		w->tm[w->tmp - 3] = w->tm[w->tmp - 2];
		w->tn[w->tmp - 3] = w->tn[w->tmp - 2];
		w->ty[w->tmp - 3] = w->ty[w->tmp - 2];
		w->tmp -= 2;
		w->opp -= 2;
		return 0;
	}
	return 1;
}

int factorial(int i)
{
	int j = 1;
	while (i > 1)
		j *= i--;
	return j;
}

int permutation(int n, int r)
{
	int i, j = 1;
	for (i = 0; i < r; i++)
		j *= n--;
	return j;
}

int combination(int n, int r)
{
	return permutation(n, r) / factorial(r);
}

// for !!
int op1f10(OpWork *w, void *fw)
{
	const unsigned char *t = newTmpBuf(w, "0:int32 ");
	(void) fw;
	opPutJck1Buf(w, "$#0 = %m1 ; $call %X ; %t = $#int32 ; ", factorial, t);
	w->tm[w->tmp - 1] = t;
	w->tn[w->tmp - 1] = 0;	// ty͂̂܂.
	return 0;
}

// for _P_, _C_
int op6f10(OpWork *w, void *fw)
{
	const unsigned char *t = newTmpBuf(w, "0:int32 ");
	opPutJck1Buf(w, "$#0 = %m3 ; $#1 = %m1 ; $call %X ; %t = $#int32 ; ", fw, t);
	w->tm[w->tmp - 3] = t;
	w->tn[w->tmp - 3] = 0;	// ty͂̂܂.
	w->tmp -= 2;
	w->opp--;
	return 0;
}

void opInit()
{
	opInit1("++ ", "0:int32 ", op1f00, "+ ");	// int32ɑ΂uPZq ++
	opInit1("++ ", "1+: ",     op1f00, "+ ");	// |C^ɑ΂uPZq ++
	opInit1("-- ", "0:int32 ", op1f00, "- ");	// int32ɑ΂uPZq --
	opInit1("-- ", "1+: ",     op1f00, "- ");	// |C^ɑ΂uPZq --

	opInit3("[ ", "[ ", "1+: ", 1);	// |C^ɑ΂zYJnZq [

	opInit4("( ", ".( ", 1);	// vZ̗D揇ʂςJnZq (

	opInit5("++ ", ".++ ", 0);	// PZq̕ϊKo^.
	opInit5("-- ", ".-- ", 0);
	opInit5("& ", ".& ", 0);
	opInit5("* ", ".* ", 0);
	opInit5("+ ", ".+ ", 0);
	opInit5("- ", ".- ", 0);
	opInit5("~ ", ".~ ", 0);
	opInit5("! ", ".! ", 0);
	opInit5("sizeof ", ".sizeof ", 0);

	opInit6("; ", 1,  1, 0, 0,			      1, opFncErr, "'; ' mikan", 0, 0);	// Z~RZq()
	opInit6(", ", 1,  1, 0, 0,			      1, opFncErr, "', ' mikan", 0, 0);	// J}Zq()
	opInit6(") ", 1, MX, 3, "op * op ",	      1, op6f0a, 0, 0, 0);	// JbRZq() (D揇ʕύXp)
	opInit6("] ", 1, MX, 3, "op 0:int32 op ", 1, op6f08, 0, 0, 0);	// pJbRZq()

	opInit6("= ",  2, 2, 3, "* op * ",	0, op6f00, 0, 0, 0);	// PZq(E)
	opInit6("+= ", 2, 2, 3, "0:int32 op 0:int32 ", 0, op6f01, "+ ", 0, 0);	// int32ɑ΂ZZq += (E)
	opInit6("+= ", 2, 2, 3, "1+: op 0:int32 ", 0, op6f01, "+ ", 0, 0);	// |C^ɑ΂ZZq += (E)
	opInit6("-= ", 2, 2, 3, "0:int32 op 0:int32 ", 0, op6f01, "- ", 0, 0);	// int32ɑ΂錸ZZq -= (E)
	opInit6("-= ", 2, 2, 3, "1+: op 0:int32 ", 0, op6f01, "- ", 0, 0);	// |C^ɑ΂錸ZZq -= (E)
	opInit6("*= ", 2, 2, 3, "0:int32 op 0:int32 ", 0, op6f01, "* ", 0, 0);	// int32ɑ΂錸ZZq *= (E)
	opInit6("/= ", 2, 2, 3, "0:int32 op 0:int32 ", 0, op6f01, "/ ", 0, 0);	// int32ɑ΂錸ZZq *= (E)

	opInit6("+ ", 13, 13, 3, "0:int32 op 0:int32 ", 0, op6f02, "+ ", 0, 0);
	opInit6("+ ", 13, 13, 3, "1+: op 0:int32 ",     0, op6f09, "+ ", 0, 0);
	opInit6("- ", 13, 13, 3, "0:int32 op 0:int32 ", 0, op6f02, "- ", 0, 0);
	opInit6("- ", 13, 13, 3, "1+: op 0:int32 ",     0, op6f09, "- ", 0, 0);
	// |C^|C^.
	opInit6("* ", 15, 15, 3, "0:int32 op 0:int32 ", 0, op6f02, "* ", 0, 0);
	opInit6("/ ", 15, 15, 3, "0:int32 op 0:int32 ", 0, op6f02, "/ ", 0, 0);
	opInit6("% ", 15, 15, 3, "0:int32 op 0:int32 ", 0, op6f02, "% ", 0, 0);

	opInit6(".++ ", 98, 98, 2, "op 0:int32 ", 0, op6f03, "+ ", 0, 0);
	opInit6(".++ ", 98, 98, 2, "op 1+: ",     0, op6f03, "+ ", 0, 0);
	opInit6(".-- ", 98, 98, 2, "op 0:int32 ", 0, op6f03, "- ", 0, 0);
	opInit6(".-- ", 98, 98, 2, "op 1+: ",     0, op6f03, "- ", 0, 0);
	opInit6(".+ ",  98, 98, 2, "op 0:int32 ", 0, op6f04, 0,    0, 0);
	opInit6(".- ",  98, 98, 2, "op 0:int32 ", 0, op6f05, "- ", 0, 0);
	opInit6(".~ ",  98, 98, 2, "op 0:int32 ", 0, op6f05, "~ ", 0, 0);
	opInit6(".& ",  98, 98, 2, "op * ",       0, op6f06, 0,    0, 0);
	opInit6(".* ",  98, 98, 2, "op 1+: ",     0, op6f07, 0,    0, 0);

	opInit1("!! ", "0:int32 ", op1f10, 0);
	opInit6("_P_ ", 17, 17, 3, "0:int32 op 0:int32 ", 0, op6f10, permutation, 0, 0);
	opInit6("_C_ ", 17, 17, 3, "0:int32 op 0:int32 ", 0, op6f10, combination, 0, 0);
}

static int pj_sub0(void **sw, unsigned char *d, const char *f, int *pi, va_list *pap)
{
	int i = *pi, j = 0, k;
	const unsigned char *t, *s = sw[1];
	int *pcf = sw[2];
	va_list ap = *pap;
	if ('0' <= f[i + 1] && f[i + 1] <= '9') {
		t = &s[pcf[f[i + 1] - '0']];
		if (f[i + 2] == '!') {	// %1! : 1ŏ].
			k = mssc(t, "== != >= <= > < ");
			if (k >= 0)
				t = &"!= == <  >  <= >= "[k * 3];
		}
		if (f[i + 2] == 'e' || f[i + 2] == 'v' || f[i + 2] == 'c') {	// %1e : 1.
			j = putJckSubExp(sw[3], 0, d - ((unsigned char *) sw[3]), s, t - s, f[i + 2]);
			if (f[i + 2] == 'v' && f[i + 3] == ' ')
				j--;
	//	} else if (f[i + 2] == 'c') {	// %1c : r.
	//		j = putJckSubCond(d, l, j, s, t - s, f[i + 3]);
		} else
			j = putJck_(d, 0, "%t", t);
	} else if (f[i + 1] == ';') {
		sw[3] = &d[j + 2];
		d[j++] = ';';
	} else
		putJck_sub0(sw, d, f, pi, pap);
	while (f[i] != ' ' && f[i] != 0) i++;
	*pi = i;
	*pap = ap;
	return j;
}

int putJck(unsigned char *d, const unsigned char *s, int *pcf, const char *f, ...)
{
	void *sw[4];
	int j;
	va_list ap;
	va_start(ap, f);
	sw[0] = pj_sub0;
	sw[1] = (void *) s;
	sw[2] = pcf;
	sw[3] = d;
	j = vPutJck_(d, sw, f, ap);
	va_end(ap);
	return j;
}

void sub_print(int i)
{
	printf("%d\n", i);
}

void sub_time()
{
	printf("time=%.3f[sec]\n", clock() / (double) CLOCKS_PER_SEC);
}

void *test_getArray()
{
	static int a[3] = { 1, 2, 3 };
	return a;
}

int test_getInt(int *p)
{
	return *p;
}

int jitL1(unsigned char *s, unsigned char *d, int siz1)
{
	int i, j, pc0, pc = 0, qc = 0, cbs[99], cbsp = 0;
	cbs[0] = 0;
	qc += putJck_(&d[qc], 0, "$startup ; ");
	for (;;) {
		pc0 = pc;
		if (qc + 64 >= siz1) { puts("jitL1: output error");	exit(1); } // obt@̕s.
		if (s[pc] == 0)	// t@CI[.
			break;
		i = mssc(&s[pc], "register label option undef lundef ");
		if (i >= 0) {
			static char *t[5] = { "$reg ", "$reserve ", "$option ", "$dev ", "$del " };
			qc += putJck_(&d[qc], 0, t[i]);
			for (pc = nextToken(s, pc); s[pc] != 0 && ssc(&s[pc], "; ") != 0; pc = nextToken(s, pc)) {
				if (ssc(&s[pc], ", ") == 0) continue;
				qc += putJck_(&d[qc], 0, "%t ", &s[pc]);
				if (i == 3)
					delTyp(&s[pc]);
			}
			qc += putJck_(&d[qc], 0, "; ");
			pc += 2;	// skip ;.
			continue;
		}
		i = mssc(&s[pc], "int char ");
		if (i >= 0) {
			pc = nextToken(s, pc);
			j = mssc(&s[pc], "* ** *** **** ") + 1;
			if (j > 0)
				pc = nextToken(s, pc);
			qc += putJck_(&d[qc], 0, "$local $int32 ");
			for (; s[pc] != 0 && ssc(&s[pc], "; ") != 0; pc = nextToken(s, pc)) {
				if (ssc(&s[pc], ", ") == 0) continue;
				qc += putJck_(&d[qc], 0, "%t ", &s[pc]);
				if (i == 0) setTyp(&s[pc], staticToken("%x:int32 ", j));
				if (i == 1) setTyp(&s[pc], staticToken("%x:int8 ", j));
			}
			qc += putJck_(&d[qc], 0, "; ");
			pc += 2;	// skip ;.
			continue;
		} else {
			static const char *phrase[] = {
				"0@ ; 									00 ",
				"0@ return ; 							00 $return ; ",
				"0@ return @@ ; 						00 $return %0e ; ",
				"0@ time ; 								ca $call 0x%x ; ",
				"0@ print @@ ; 							cb $#0 = %0e ; $call 0x%x ; ",
				"0@ @ : 								00 $label %0 ; ",
				"0@ goto @ ; 							00 $goto %0 ; ",
				"0@ break ; 							00 $goto .break ; ",
				"0@ continue ; 							00 $goto .continue ; ",
				"0@ continue0 ; 						00 $goto .continue0 ; ",
				"0@ if ( @ @ @ ) goto @ ; 				00 $if %0 %1 %2 $goto %3 ; ",
				"0@ if ( @ @ @ ) break ; 				00 $if %0 %1 %2 $goto .break ; ",
				"0@ if ( @ @ @ ) continue ; 			00 $if %0 %1 %2 $goto .continue ; ",
				"0@ if ( @ @ @ ) continue0 ; 			00 $if %0 %1 %2 $goto .continue0 ; ",
				"0@ if ( @ @ @ ) { 						01 $reserve .else .fi %; $if %0 %1! %2 $goto .else ; ",
				"1@ } else if ( @ @ @ ) { 				01 $goto .fi ; $label .else ; $del .else ; $reserve .else %; $if %0 %1! %2 $goto .else ; ",
				"1@ } else { 							-2 $goto .fi ; $label .else ; ",
				"1@ } 									-0 $label .else ; $del .else .fi ; ",
				"2@ } 									-0 $label .fi ; $del .else .fi ; ",
				"0@ do { 								03 $reserve .break .continue ; $label .continue0 ; ",
				"3@ } while ( @ @ @ ) ; 				-0 $label .continue %; $if %0 %1 %2 $goto .continue0 ; $label .break ; $del .continue0 .break .continue ; ",
				"0@ while ( @ @ @ ) { 					04 $reserve .break ; $label .continue %; $if %0 %1! %2 $goto .break ; $label .continue0 ; ",
				"4@ } 									-0 $if %0 %1 %2 $goto .continue0 ; $label .break ; $del .continue0 .break .continue ; ",
				"0@ for ( @@ ; @ @ @ ; @@ ) { 			05 %0v $reserve .break ; $label .continue %; $if %1 %2! %3 $goto .break ; $label .continue0 ; ",
				"5@ } 									-0 $label .continue %; %4v $if %1 %2 %3 $goto .continue0 ; $label .break ; $del .continue0 .break .continue ; ",
				"0@ @ = testArray ;  					cc $call 0x%x %; %0 = $#int32 ; ",
				"0@ @ = getInt ( @@ ) ;  				cd $#0 = %1e ; $call 0x%x %; %0 = $#int32 ; ",
				"0@ @@ ; 								00 %0v ",
				0
			};
			for (i = 0; phrase[i] != 0; i++) {
				const char *ph = phrase[i];
				int j, k, kb[9];
				if (ph[0] != '0' && cbs[cbsp] != ph[0]) continue;
				j = testPhrase(s, pc, ph[1], &ph[3], kb);
				if (j <= 0) continue;
				pc = kb[0];
				j += 3;
				while (ph[j] <= ' ')
					j++;
				if (ph[j] == '-') {
					cbsp--;
					if (cbs[cbsp + 1] >= '4') {
						for (k = 8; k >= 0; k--)
							kb[k] = cbs[cbsp--];
					}
				}
				if ('1' <= ph[j + 1] && ph[j + 1] <= '9') {
					if (ph[j + 1] >= '4') {
						for (k = 0; k <= 8; k++)
							cbs[++cbsp] = kb[k];
					}
					cbs[++cbsp] = ph[j + 1];
				}
				k = 0;
				if (ph[j] == 'c') {
					static void *t[] = { sub_time, sub_print, test_getArray, test_getInt };
					k = (int) t[ph[j + 1] - 'a'];
				}
				qc += putJck(&d[qc], s, kb + 1, &ph[j + 3], k);
				break;
			}
			if (phrase[i] == 0) goto err;
		}
	}
	qc += putJck_(&d[qc], 0, "$return ; ");
	d[qc] = 0;
	return qc;
err:
	printf("jitL1: syntax error : %.20s\n", &s[pc0]);
	exit(1);
}

int main(int argc, const char **argv)
{
	static char *errmsg[] = { "OUTPUT", "SYNTAX", 0, "OVRDEF", "UNDEF", "INTERNAL" };
	unsigned char *code = mallocRWX(1024 * 1024);
	int i, j, pc0, pc1, pc2, cc;
	void (*func)();	// func͊֐ւ̃|C^^̕ϐ.
	opInit();
	loadText(argc, argv, txt, 10000);
	lexer(txt, t0, 10000, 0);
	jck1t[0] = ' ';
	jitL1(t0 + 1, jck1t + 1, 10000);
	if (argc >= 3 && argv[2][0] == '1') { puts(jck1t); exit(0); }	// dump-jck1.
	do {
		i = jck1(jck1t, jck0t, 10000, &pc0, &pc1, &pc2, &cc);
		if (i < 0) {
			printf("jck1: ERR_%s: '%.*s'    [pos] %.40s\n", errmsg[-1 - i], (unsigned char *) strchr(&jck1t[pc1], ' ') - &jck1t[pc1], &jck1t[pc1], &jck1t[pc0]);
			exit(1);
		}
		if (argc >= 3 && argv[2][0] == '0') printf("[cc=%d] %s\n", cc, jck0t);
		if (jck1t == jck1t_) {
			jck1t = jck0t_;
			jck0t = jck1t_;
		} else {
			jck1t = jck1t_;
			jck0t = jck0t_;
		}
	} while (cc > 0);
	if (argc >= 3 && argv[2][0] == '0') exit(0);	// dump-jck0.
	i = jck0(jck0t, code, 1024 * 1024, &pc0, &pc1, &pc2);
	if (i < 0) {
		printf("jck0: ERR_%s: '%.*s'    [pos] %.40s\n", errmsg[-1 - i], (unsigned char *) strchr(&jck0t[pc1], ' ') - &jck0t[pc1], &jck0t[pc1], &jck0t[pc0]);
		exit(1);
	}
	if (argc >= 3 && argv[2][0] == 'b') { for (j = 0; j < i; j++) printf("%02x ", code[j]); printf("\ntotal=%d[bytes]\n", i); exit(0); }	// dump-binary.
	func = (void *) code;
	func();
	exit(0);
}
